给你一个 无重复元素 的整数数组 candidates 和一个目标整数 target ,找出 candidates 中可以使数字和为目标数 target 的 所有 不同组合 ,并以列表形式返回。你可以按 任意顺序 返回这些组合。
candidates 中的 同一个 数字可以 无限制重复被选取 。如果至少一个数字的被选数量不同,则两种组合是不同的。
对于给定的输入,保证和为 target 的不同组合数少于 150 个。
示例 1:
输入:candidates = [2,3,6,7], target = 7
输出:[[2,2,3],[7]]
解释:
2 和 3 可以形成一组候选,2 + 2 + 3 = 7 。注意 2 可以使用多次。
7 也是一个候选, 7 = 7 。
仅有这两种组合。
示例 2:
输入: candidates = [2,3,5], target = 8
输出: [[2,2,2,2],[2,3,3],[3,5]]
示例 3:
输入: candidates = [2], target = 1
输出: []
提示:
1 <= candidates.length <= 30
1 <= candidates[i] <= 200
candidate 中的每个元素都 互不相同
1 <= target <= 500
来源:力扣(LeetCode)
链接:https://leetcode.cn/problems/combination-sum
思路:回溯算法秒杀所有排列/组合/子集问题 :: labuladong的算法小抄
回溯算法
java:
- class Solution {
- public List<List<Integer>> combinationSum(int[] candidates, int target) {
- List<List<Integer>> result = new LinkedList<>();
-
- backtrack1(candidates,target,0,0,new LinkedList<>(),result);
- return result;
- }
-
- public void backtrack1(int[] candidates, int target, int start,int subSum, List<Integer> subSet, List<List<Integer>> result) {
-
- // 递归终止条件,组合的和等于 target,则将组合放到 result 中
- if(subSum==target) {
- result.add(new LinkedList<>(subSet));
- return;
- }
-
- // 递归终止条件,组合的和大于 target,说明不必再遍历下去
- if(subSum>target) {
- return;
- }
-
- for(int i=start;i<candidates.length;i++) {
- subSet.add(candidates[i]);
- subSum += candidates[i];
-
- // 因为元素的可复选的,所以下次遍历仍然课从 i 开始
- backtrack1(candidates,target,i,subSum,subSet,result);
-
- subSet.remove(subSet.size()-1);
- subSum -= candidates[i];
- }
-
- }
- }
c++
- class Solution {
- public:
- vector<vector<int>> result;
- vector<vector<int>> combinationSum(vector
& candidates, int target) { - if(candidates.size() == 0) {
- return result;
- }
-
- vector<int> sub_vec;
- dfs(candidates, target, 0, sub_vec);
-
- return result;
- }
-
- void dfs(vector<int>& candidates, int target, int start, vector<int>& sub_vec) {
- if(target < 0) {
- return;
- }
- if(target == 0) {
- result.push_back(sub_vec);
- return;
- }
-
- for(int i=start; i<candidates.size(); i++) {
- sub_vec.push_back(candidates[i]);
- dfs(candidates, target-candidates[i], i, sub_vec);
- sub_vec.pop_back();
- }
-
- }
-
- };